module = module.exports = {
    getAllLinks: (datasource, completeUri, relations, apiUri) => {
        return datasource.map((row) => {
            row.uri = getLinks(row.id, completeUri);
            row.deeplinks = getDeeplinks(row.id, completeUri, relations, apiUri);
            return row;
        });
    },
    getLinks: (row, completeUri, relations, apiUri) => {
        row.uri = getLinks(row.id, completeUri);
        row.deeplinks = getDeeplinks(row.id, completeUri, relations, apiUri);
        return row;
    },
    getPostLinks: (id, completeUri) => {
        return getLinks(id, completeUri);
    },
    getEditLinks: (row, completeUri) => {
        row.uri = getLinks(row.id, completeUri);
        return row;
    }
}

function getLinks(id, completeUri) {
    return completeUri + '/' + id;
}

function getDeeplinks(id, completeUri, relations, apiUri) {
    let deeplinks = {};
    for (var relation in relations) {
        if (relations[relation].asFilter) {
            deeplinks[relation] = apiUri + '/' + relation + '?' + relations[relation].column + '=' + id;
        } else {
            deeplinks[relation] = completeUri + '/' + id + '/' + relation;
        }
    }
    return deeplinks;
}